export declare function createDateFromYYYYMMDD(dateString: string): Date;
export declare function newSafeDate(): Date;
export declare function addDaysToDate(date: Date, days: number): Date;
export declare function addWeeksToDate(date: Date, weeks: number): Date;
export declare function startOfDay(date: Date): Date;
export declare function endOfDay(date: Date): Date;
export declare function endOfMonth(date: Date): Date;
export declare function endOfYear(date: Date): Date;
export declare function getDayDifference(date1: Date, date2: Date): number;
export declare function getWeekDifference(date1: Date, date2: Date): number;
/**
 *
 * @returns 1 for Monday, 2 for Tuesday, etc. 7 for Sunday
 */
export declare function getIsoWeekDay(date: Date): number;
export declare function setIsoWeekDay(date: Date, day: number): Date;
export declare function getDayOfYear(date: Date): number;
/**
 * Returns formatted string in (YYYY-MM-DD) format
 */
export declare function toFormattedString(date: Date): string;
export declare function parseIntBase10(value: string): number;
